# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project adheres to [Semantic Versioning](http://semver.org/).

## [0.6.5] - 2021-06-26

- yarn-lock: Remove `protolude` dependency in order to add to `stackage`.
- Relax upper bound of `hnix`.

## [0.6.4] - 2021-03-30

- Repository changed to https://github.com/Profpatsch/yarn2nix

## [0.6.3] - 2021-03-29

- Relax upper bounds of `protolude` and `megaparsec`.

## [0.6.2] - 2019-12-22

- `megaparsec` `0.8` is compatible as well as `0.7`.
- Support for local and remote file source remotes without hashes. Some old versions of might have these. `FileRemoteNoIntegrity` and `FileLocalNoIntegrity`.

## [0.6.1] - 2019-11-03

- Update `megaparsec` dependency to `0.7`.

## [0.6.0] - 2018-12-19

### Added

- Support for local dependencies (`resolved` field starts with `file:`)

### Fixed

- Semigroup is superclass of Monoid

## [0.5.0] - 2018-06-12

### Changed

- `PackageKey`s now correctly parse scoped npm names
  - This means `Text` is now a sum of `SimplePackageKey`/`ScopedPackageKey`

### Fixed

- `PackageKey`s with versions containing `@` parse correctly
  - Like for example `git+ssh:git@github.com` links for some git packages

## [0.4.1] - 2018-05-15

### Changed

- Update the parser to `megaparsec 6.*`
- Raise `protolude` minimal version to `0.2.*`

### Fixed

- Import missing quickcheck `NonEmpty` instances from `quickcheck-orphans`

## [0.4.0] - 2017-10-07

### Changed
- MKMap functions `fromList` and `toList` only take non-empty key lists

## [0.3.4] - 2017-10-04

### Fixed
- Support for Protolude 0.2.* ((<>) is exported from Monoid, not Semigroup)

## [0.3.3] - 2017-10-04

### Fixed
- Remove (broken) support for megaparsec 6.*

## [0.3.2] - 2017-10-02

### Fixed
- Support parsing packages with `@` in the package name 

## [0.3.1] - 2017-08-16

### Added
- Functor, Foldable and Traversable instances for MKMap

### Fixed
- Remote URL parsing strips more unneeded elements

## [0.3] - 2017-08-16

This is a major overhaul, changing nearly every part of the API
and the implementation!

### Added
- Support for multiple kinds of remote.
- Heuristics for parsing git and file remotes.
- Helpful, local error messages if the parsing goes wrong somewhere
- A convenience function for doing all parsing steps at once
- A pretty printer for error messages
- Tests for all parsing logic
- Tests for simple invariants in the multi-keyed map implementation

### Changed
- Split the code into multiple modules.
- Rewrote the parser to have a separate AST parsing step.

## [0.2] - 2017-05-21

### Added
- A multi-keyed map module.
- `decycle` function for removing npm dependency cycles.

### Changed
- Lockfile type is now a multi-keyed map.


## [0.1] - 2017-04-18

### Added
- Parser for `yarn.lock` files generated by yarn.
- Data types representing the yarn file.
- Lockfile type that is a simple `Map`.


